> ## Documentation Index
> Fetch the complete documentation index at: https://docs.domino.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Model Operations.



## OpenAPI

````yaml /api-specs/6.3/dmm.yaml put /model-monitor/v2/api/model
openapi: 3.0.3
info:
  title: Domino Model Monitor API
  description: The API for programmatic access to Domino Model Monitor.
  version: 1.0.1
servers: []
security: []
tags:
  - name: DatasetJob
    description: All Dataset Job related operations.
  - name: DataSource
    description: All data source related operations.
  - name: Model
    description: All Model related operations.
  - name: ModelTag
    description: Operations related to the management of model tags.
  - name: ModelDrift
    description: All Model drift related operations.
  - name: ModelQuality
    description: All Model quality related operations.
  - name: Workbench
    description: All Workbench related operations.
  - name: DefaultSettings
    description: Operations related to drift and model quality defaults setting in DMM.
  - name: UserSettings
    description: Operations related to configuring user related settings for DMM.
  - name: Notification
    description: >-
      Operations related to configuring notification channel config and alert
      recipients for the model.
  - name: Other
    description: Other miscellaneous operations.
  - name: Scheduler
    description: All scheduler related operations
paths:
  /model-monitor/v2/api/model:
    summary: Model Operations.
    put:
      tags:
        - Model
      summary: Model Operations.
      operationId: registerModelThroughConfig
      requestBody:
        required: true
        description: ''
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/modelRegistrationConfigRequest'
      responses:
        '200':
          description: Successfully registered the Model.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/modelResponse'
        '400':
          description: Bad request input data.
        '403':
          description: Forbidden. The endpoint enforces permissions.
        '405':
          description: Method not allowed.
        '500':
          description: Internal server error, check server logs.
      security:
        - DominoApiKeyAuth: []
        - DmmApiKeyAuth: []
        - cookieAuth: []
components:
  schemas:
    modelRegistrationConfigRequest:
      title: Model Registration Config
      description: Config to be used to register a model with DMM.
      allOf:
        - $ref: '#/components/schemas/datasetRegistrationConfigRequest'
        - type: object
          required:
            - modelMetadata
          properties:
            modelMetadata:
              $ref: '#/components/schemas/model'
    modelResponse:
      allOf:
        - $ref: '#/components/schemas/modelResponseCommon'
        - type: object
          properties:
            permissions:
              $ref: '#/components/schemas/modelPermissions'
    datasetRegistrationConfigRequest:
      title: Model Registration Config
      description: Config to be used to register a model with DMM.
      type: object
      required:
        - datasetDetails
      properties:
        variables:
          type: array
          items:
            $ref: '#/components/schemas/variableConfigRegistrationRequest'
        datasetDetails:
          $ref: '#/components/schemas/datasetConfigRegistrationRequest'
        run_cohort_analysis:
          type: boolean
    model:
      title: Model Config
      description: Model Config to be used to register a model with DMM.
      type: object
      required:
        - name
        - modelType
        - version
      properties:
        name:
          description: Name of the Model.
          type: string
        modelType:
          description: Type of the Model.
          type: string
          enum:
            - classification
            - regression
        version:
          description: Version of the Model.
          type: string
        description:
          description: Description for the Model.
          type: string
        author:
          description: Author of the Model.
          type: string
        dateCreated:
          description: The creation date of the model.
          type: integer
          nullable: true
        sourceType:
          $ref: '#/components/schemas/sourceType'
        sourceDetails:
          $ref: '#/components/schemas/workbenchModelDetails'
    modelResponseCommon:
      allOf:
        - $ref: '#/components/schemas/model'
        - type: object
          required:
            - id
            - createdAt
            - updatedAt
            - userId
            - ingestionStatus
            - registrationStatus
            - isDeleted
          properties:
            id:
              description: Model Identifier.
              type: string
            createdAt:
              description: Creation timestamp of the Model.
              type: integer
            updatedAt:
              description: Last update timestamp for the Model.
              type: integer
            userId:
              description: Id of the model owner, who created the model.
              type: string
            ownerUsername:
              description: username of the model owner, who created the model.
              type: string
            ownerEmail:
              description: email of the model owner, who created the model.
              type: string
            ownerName:
              description: name of the model owner, who created the model.
              type: string
            tags:
              description: List of tags associated with the model
              type: array
              items:
                $ref: '#/components/schemas/modelTag'
            ingestionStatus:
              description: Dataset Ingestion status for a model.
              type: string
              enum:
                - created
                - training
                - prediction
                - ground_truth
            registrationStatus:
              description: Registration status of a model.
              type: string
              enum:
                - draft
                - created
                - deleted
            isDeleted:
              description: Whether the model is deleted or not.
              type: boolean
            visibility:
              $ref: '#/components/schemas/visibility'
            collaborators:
              type: array
              items:
                $ref: '#/components/schemas/collaborator'
    modelPermissions:
      title: Model Permissions
      description: Permission metadata required for a model response
      type: object
      required:
        - canRegisterDataset
        - canUpdateMonitoringSettings
        - canEditPermissions
      properties:
        canRegisterDataset:
          description: Whether the requesting user can register a dataset for the model
          type: boolean
        canUpdateMonitoringSettings:
          description: >-
            Whether the requesting user can update monitoring settings for the
            model
          type: boolean
        canEditPermissions:
          description: Whether the requesting user can edit permissions for the model
          type: boolean
    variableConfigRegistrationRequest:
      title: Variable Config Registration
      description: Variable config to configure a variable of a model.
      type: object
      required:
        - name
        - valueType
        - variableType
      properties:
        name:
          description: Name of the variable.
          type: string
        valueType:
          $ref: '#/components/schemas/valueType'
        variableType:
          $ref: '#/components/schemas/variableType'
        binsCategories:
          description: Bin categories to be used for a categorical typed variable.
          type: array
          items:
            type: string
        binsEdges:
          description: Bin Edges to be used for a numerical typed variable.
          type: array
          items:
            type: number
        binsNum:
          $ref: '#/components/schemas/binCount'
        binsEstimatorMethod:
          $ref: '#/components/schemas/binsEstimatorMethod'
        featureImportance:
          description: Feature Importance for a feature variable.
          type: number
        precomputedBinCounts:
          description: Precomputed counts for bins.
          type: array
          items:
            type: integer
        predictionProbabilityLabels:
          description: Labels for the prediction probabilities.
          type: array
          items:
            type: string
        forPredictionOutput:
          description: Corresponding prediction variable name, for the given variable.
          type: string
    datasetConfigRegistrationRequest:
      title: Dataset Config Registration
      description: Config for the dataset to be registered with the model.
      type: object
      required:
        - name
        - datasetType
        - datasetConfig
        - datasourceName
        - datasourceType
      properties:
        name:
          description: Name of the dataset.
          type: string
        datasetType:
          description: Type of the dataset.
          type: string
          enum:
            - file
        datasetConfig:
          $ref: '#/components/schemas/datasetConfig'
        datasourceName:
          description: Name of the datasource to which the dataset belongs.
          type: string
        datasourceType:
          $ref: '#/components/schemas/datasourceType'
        featureSetId:
          description: The version id for the current feature set version.
          type: string
        featureSetVersionId:
          description: >-
            The feature set id of the feature set to which the current feature
            set version belongs to.
          type: string
    sourceType:
      description: Source for the model registration.
      type: string
      enum:
        - domino_workbench
        - standalone
    workbenchModelDetails:
      title: Domino Workbench model's details.
      description: Model details associated with a Domino workbench model.
      type: object
      required:
        - workbenchModelId
        - workbenchModelVersionId
      properties:
        workbenchModelId:
          description: Workbench's Model id
          type: string
        workbenchModelVersionId:
          description: Workbench Model's version id to be monitored in DMM
          type: string
    modelTag:
      title: Model Tag
      description: Tag for a model
      required:
        - id
        - tagName
      properties:
        id:
          type: string
        tagName:
          description: name of tag
          type: string
    visibility:
      description: Model visibility
      type: string
      enum:
        - public
        - private
    collaborator:
      description: Collaborator for a standalone model
      type: object
      required:
        - userId
        - collaboratorLevel
      properties:
        userId:
          description: user id of the collaborator
          type: string
        collaboratorLevel:
          $ref: '#/components/schemas/collaboratorLevel'
    valueType:
      description: Type of data the variable has.
      type: string
      enum:
        - categorical
        - numerical
        - string
        - datetime
    variableType:
      description: Variable type.
      type: string
      enum:
        - feature
        - prediction
        - row_identifier
        - timestamp
        - ground_truth
        - sample_weight
        - prediction_probability
    binCount:
      description: Number of bins to be determined (for training datasets)
      type: integer
    binsEstimatorMethod:
      description: Estimator method to be used to determine the number of bins.
      type: string
      enum:
        - auto
        - doane
        - fd
        - rice
        - scott
        - sqrt
        - sturges
    datasetConfig:
      type: object
      description: Config for the dataset.
      required:
        - path
        - fileFormat
      properties:
        path:
          description: Path to the dataset in the datasource.
          type: string
        fileFormat:
          $ref: '#/components/schemas/fileFormat'
    datasourceType:
      description: Type of the datasource to which the dataset belongs.
      type: string
      enum:
        - s3
        - generic_s3
        - azure_blob
        - azure_data_lake_gen_2
        - google_cloud_storage
        - azure_data_lake_gen_1
        - hdfs
        - nfs
        - snowflake
    collaboratorLevel:
      description: type of collaborator
      type: string
      enum:
        - editor
        - viewer
    fileFormat:
      description: Format of the file.
      type: string
      enum:
        - csv
        - parquet
        - snowflake
  securitySchemes:
    DominoApiKeyAuth:
      type: apiKey
      in: header
      name: X-Domino-Api-Key
    DmmApiKeyAuth:
      type: apiKey
      in: header
      name: X-DMM-API-KEY
    cookieAuth:
      type: apiKey
      in: cookie
      name: PLAY_SESSION

````